﻿namespace Falcon.SugarApi.DatabaseManager
{
    /// <summary>
    /// 字段加密解密方法
    /// </summary>
    public interface IEncrypt
    {
        /// <summary>
        /// 加密。当存储字段值进入数据库时使用该方法进行加密
        /// </summary>
        /// <param name="str">字段明文值</param>
        /// <returns>字段密文</returns>
        string Encrypt(string str);
        /// <summary>
        /// 解密。当读取字段内容时对数据库中的加密值进行解密
        /// </summary>
        /// <param name="str">字段密文</param>
        /// <returns>字段明文值</returns>
        string Decrypt(string str);
    }
}
