﻿using Microsoft.AspNetCore.Cors.Infrastructure;

namespace Falcon.SugarApi.FalconCors
{
    /// <summary>
    /// CorsPolicy装饰器
    /// </summary>
    public class CorsPolicyWallpaper:CorsPolicy
    {
        /// <summary>
        /// 通过一个CorsOptions构建CorsPolicy
        /// </summary>
        /// <param name="options">跨域请求参数</param>
        public CorsPolicyWallpaper(CorsOptions? options) {
            if(options == null) {
                return;
            }
            if(options.AllowCredentials != null) {
                this.SupportsCredentials = options.AllowCredentials.Value;
            }
            if(options.Headers.IsNotNullOrEmpty()) {
                this.Headers.Clear();
                options.Headers.SplitToStringList().ForEach(a => this.Headers.Add(a));
            }
            if(options.Methods.IsNotNullOrEmpty()) {
                this.Methods.Clear();
                options.Methods.SplitToStringList().ForEach(a => this.Methods.Add(a));
            }
            if(options.Origins.IsNotNullOrEmpty()) {
                this.Origins.Clear();
                options.Origins.SplitToStringList().ForEach(a => this.Origins.Add(a));
            }
        }
    }
}
