﻿using Microsoft.Extensions.DependencyInjection;

namespace Falcon.SugarApi.TimedBackgroundTask
{
    /// <summary>
    /// 服务集合扩展方法
    /// </summary>
    public static class IServiceCollectionExtend
    {
        /// <summary>
        /// 向HostService中注册TimedBackgroundTask服务
        /// </summary>
        /// <typeparam name="T">TimedBackgroundTask的具体类型</typeparam>
        /// <param name="services">服务集合</param>
        /// <returns>服务集合</returns>
        public static IServiceCollection AddTimedTask<T>(this IServiceCollection services)
            where T : TimedTask {
            services.AddHostedService<T>();
            return services;
        }
    }
}
